/**
 * 
 */
package org.gcube.accounting.datamodel.usagerecords;

import java.util.Set;

import org.gcube.accounting.datamodel.basetypes.TestUsageRecord;
import org.gcube.common.authorization.library.provider.SecurityTokenProvider;
import org.gcube.documentstore.exception.InvalidValueException;
import org.gcube.utils.TestUtility;
import org.junit.After;
import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * @author Luca Frosini (ISTI - CNR) http://www.lucafrosini.com/
 *
 */
public class JobUsageRecordScopedTest extends JobUsageRecordTest {
	
	private static Logger logger = LoggerFactory.getLogger(JobUsageRecordScopedTest.class);
	
	@Before
	public void before() throws Exception{
		SecurityTokenProvider.instance.set(TestUtility.TOKEN);
	}
	
	@After
	public void after() throws Exception{
		SecurityTokenProvider.instance.reset();
	}
	
	
	@Test
	public void testRequiredFieldsScoped() throws InvalidValueException{
		JobUsageRecord usageRecord = TestUsageRecord.createTestJobUsageRecord();
		
		Set<String> expectedRequiredFields = getExpectedRequiredFields();
		logger.debug("Expected Required Fields : {}", expectedRequiredFields);
		
		Set<String> gotRequiredFields = usageRecord.getRequiredFields();
		logger.debug("Got Required Fields : {}", gotRequiredFields);
		
		Assert.assertTrue(expectedRequiredFields.containsAll(gotRequiredFields));
		Assert.assertTrue(gotRequiredFields.containsAll(expectedRequiredFields));
		
		usageRecord.validate();
		logger.debug("{}", usageRecord);
	}

}
